3 # Desc: Records gps data until midnight
4 # Author: Steven Baltakatei Sandoval; License: GPLv3+
5 # Usage: bkgpslog -o [output dir]
7 #==BEGIN Define script parameters==
8 ## Logging Behavior parameters
9 BUFFER_TTL
="60"; # time between file writes
10 SCRIPT_TTL
="day"; # (day|hour)
11 #### TZ="UTC"; export TZ; # Default time zone; overridden by '--time-zone=[str]' option
12 DIR_TMP_DEFAULT
="/dev/shm"; # Default parent of working directory
14 SCRIPT_TIME_START
=$
(date +%Y
%m
%dT
%H
%M
%S.
%N
);
15 PATH
="$HOME/.local/bin:$PATH"; # Add "$(systemd-path user-binaries)" path in case apps saved there
16 SCRIPT_HOSTNAME
=$
(hostname
); # Save hostname of system running this script.
17 SCRIPT_VERSION
="bkgpslog 0.1.0"; # Define version of script.
19 declare -Ag appRollCall
# Associative array for storing app status
20 declare -Ag fileRollCall
# Associative array for storing file status
21 declare -Ag dirRollCall
# Associative array for storing dir status
22 declare -a recPubKeys
# for processArguments function
23 declare recipients
# for main function
25 ## Initialize variables
26 OPTION_VERBOSE
=""; OPTION_ENCRYPT
=""; OPTION_COMPRESS
=""; OPTION_TMPDIR
="";
28 #===BEGIN Declare local script functions===
30 # Desc: If arg is a command, save result in assoc array 'appRollCall'
31 # Usage: checkapp arg1 arg2 arg3 ...
32 # Input: global assoc. array 'appRollCall'
33 # Output: adds/updates key(value) to global assoc array 'appRollCall'
35 #echo "DEBUG:$(date +%S.%N)..Starting checkapp function."
36 #echo "DEBUG:args: $@"
37 #echo "DEBUG:returnState:$returnState"
41 #echo "DEBUG:processing arg:$arg"
42 if command -v "$arg" 1>/dev
/null
2>&1; then # Check if arg is a valid command
43 appRollCall
[$arg]="true";
44 #echo "DEBUG:appRollCall[$arg]:"${appRollCall[$arg]}
45 if ! [ "$returnState" = "false" ]; then returnState
="true"; fi
47 appRollCall
[$arg]="false"; returnState
="false";
51 #for key in "${!appRollCall[@]}"; do echo "DEBUG:$key => ${appRollCall[$key]}"; done
52 #echo "DEBUG:evaluating returnstate. returnState:"$returnState
54 #===Determine function return code===
55 if [ "$returnState" = "true" ]; then
56 #echo "DEBUG:checkapp returns true for $arg";
59 #echo "DEBUG:checkapp returns false for $arg";
62 } # Check that app exists
64 # Desc: If arg is a file path, save result in assoc array 'fileRollCall'
65 # Usage: checkfile arg1 arg2 arg3 ...
66 # Input: global assoc. array 'fileRollCall'
67 # Output: adds/updates key(value) to global assoc array 'fileRollCall';
68 # Output: returns 0 if app found, 1 otherwise
73 #echo "DEBUG:processing arg:$arg"
74 if [ -f "$arg" ]; then
75 fileRollCall
["$arg"]="true";
76 #echo "DEBUG:fileRollCall[\"$arg\"]:"${fileRollCall["$arg"]}
77 if ! [ "$returnState" = "false" ]; then returnState
="true"; fi
79 fileRollCall
["$arg"]="false"; returnState
="false";
83 #for key in "${!fileRollCall[@]}"; do echo "DEBUG:fileRollCall key [$key] is:${fileRollCall[$key]}"; done
84 #echo "DEBUG:evaluating returnstate. returnState:"$returnState
86 #===Determine function return code===
87 if [ "$returnState" = "true" ]; then
88 #echo "DEBUG:checkapp returns true for $arg";
91 #echo "DEBUG:checkapp returns false for $arg";
94 } # Check that file exists
96 # Desc: If arg is a dir path, save result in assoc array 'dirRollCall'
97 # Usage: checkdir arg1 arg2 arg3 ...
98 # Input: global assoc. array 'dirRollCall'
99 # Output: adds/updates key(value) to global assoc array 'dirRollCall';
100 # Output: returns 0 if app found, 1 otherwise
105 #echo "DEBUG:processing arg:$arg"
106 if [ -d "$arg" ]; then
107 dirRollCall
["$arg"]="true";
108 #echo "DEBUG:dirRollCall[\"$arg\"]:"${dirRollCall["$arg"]}
109 if ! [ "$returnState" = "false" ]; then returnState
="true"; fi
110 elif [ "$arg" = "" ]; then
111 dirRollCall
["$arg"]="false"; returnState
="false";
117 #for key in "${!dirRollCall[@]}"; do echo "DEBUG:dirRollCall key [$key] is:${dirRollCall[$key]}"; done
118 #echo "DEBUG:evaluating returnstate. returnState:"$returnState
120 #===Determine function return code===
121 if [ "$returnState" = "true" ]; then
122 #echo "DEBUG:checkapp returns true for $arg";
125 #echo "DEBUG:checkapp returns false for $arg";
128 } # Check that dir exists
130 # Yell, Die, Try Three-Fingered Claw technique
131 # Ref/Attrib: https://stackoverflow.com/a/25515370
132 yell
() { echo "$0: $*" >&2; }
133 die
() { yell
"$*"; exit 111; }
134 try
() { "$@" || die
"cannot $*"; }
137 echo "$@" 1>&2; # Define stderr echo function.
138 } # Define stderr message function.
141 echoerr
" bkgpslog [ options ]"
144 echoerr
" -h, --help"
145 echoerr
" Display help information."
148 echoerr
" Display script version."
150 echoerr
" -v, --verbose"
151 echoerr
" Display debugging info."
153 echoerr
" -e, --encrypt"
154 echoerr
" Encrypt output."
156 echoerr
" -r, --recipient [ pubkey string ]"
157 echoerr
" Specify recipient. May be age or ssh pubkey."
158 echoerr
" See https://github.com/FiloSottile/age"
160 echoerr
" -o, --output [ directory ]"
161 echoerr
" Specify output directory to save logs."
163 echoerr
" -c, --compress"
164 echoerr
" Compress output with gzip (before encryption if enabled)."
166 echoerr
" -z, --time-zone"
167 echoerr
" Specify time zone. (ex: \"America/New_York\")"
169 echoerr
" -t, --temp-dir"
170 echoerr
" Specify parent directory for temporary working directory."
171 echoerr
" Default: \"/dev/shm\""
173 echoerr
"EXAMPLE: (bash script lines)"
174 echoerr
"/bin/bash bkgpslog -e -c \\"
175 echoerr
"-r age1mrmfnwhtlprn4jquex0ukmwcm7y2nxlphuzgsgv8ew2k9mewy3rs8u7su5 \\"
176 echoerr
"-r age1ala848kqrvxc88rzaauc6vc5v0fqrvef9dxyk79m0vjea3hagclswu0lgq \\"
177 echoerr
"-o ~/Sync/Location"
178 } # Display information on how to use this script.
180 echoerr
"$SCRIPT_VERSION"
181 } # Display script version.
183 # Usage: vbm "DEBUG:verbose message here"
184 # Description: Prints verbose message ("vbm") to stderr if OPTION_VERBOSE is set to "true".
186 # - OPTION_VERBOSE variable set by processArguments function. (ex: "true", "false")
187 # - "$@" positional arguments fed to this function.
189 # Script function dependencies: echoerr
190 # External function dependencies: echo
191 # Last modified: 2020-04-11T23:57Z
192 # Last modified by: Steven Baltakatei Sandoval
196 if [ "$OPTION_VERBOSE" = "true" ]; then
197 FUNCTION_TIME
=$
(date --iso-8601=ns
); # Save current time in nano seconds.
198 echoerr
"[$FUNCTION_TIME] ""$*"; # Display argument text.
202 return 0; # Function finished.
203 } # Verbose message display function.
205 while [ ! $# -eq 0 ]; do # While number of arguments ($#) is not (!) equal to (-eq) zero (0).
206 #echoerr "DEBUG:Starting processArguments while loop."
207 #echoerr "DEBUG:Provided arguments are:""$*"
209 -h |
--help) showUsage
; exit 1;; # Display usage.
210 --version) showVersion
; exit 1;; # Show version
211 -v |
--verbose) OPTION_VERBOSE
="true"; vbm
"DEBUG:Verbose mode enabled.";; # Enable verbose mode.
212 -o |
--output) if [ -d "$2" ]; then DIR_OUT
="$2"; vbm
"DEBUG:DIR_OUT:$DIR_OUT"; shift; fi ;; # Define output directory.
213 -e |
--encrypt) OPTION_ENCRYPT
="true"; vbm
"DEBUG:Encrypted output mode enabled.";;
214 -r |
--recipient) # Add 'age' recipient via public key string
215 recPubKeys
+=("$2"); vbm
"pubkey added:""$2"; shift;;
216 -c |
--compress) OPTION_COMPRESS
="true"; vbm
"DEBUG:Compressed output mode enabled.";;
217 -z |
--time-zone) try setTimeZoneEV
"$2";;
218 -t |
--temp-dir) OPTION_TMPDIR
="true" && TMP_DIR_PRIORITY
="$2";;
219 *) echoerr
"ERROR: Unrecognized argument: $1"; echoerr
"STATUS:All arguments:$*"; exit 1;; # Handle unrecognized options.
223 } # Argument Processing
225 # Desc: Set time zone environment variable TZ
226 # Usage: setTimeZoneEV arg1
227 # Input: arg1: 'date'-compatible timezone string (ex: "America/New_York")
228 # TZDIR env var (optional; default: "/usr/share/zoneinfo")
230 # exit code 0 on success
231 # exit code 1 on incorrect number of arguments
232 # exit code 2 if unable to validate arg1
233 # Depends: yell, printenv, bash 5
234 # Tested on: Debian 10
236 local tzDir returnState
237 if ! [[ $# -eq 1 ]]; then
238 yell
"ERROR:Invalid argument count.";
242 # Read TZDIR env var if available
243 if printenv TZDIR
1>/dev
/null
2>&1; then
244 tzDir
="$(printenv TZDIR)";
246 tzDir
="/usr/share/zoneinfo";
250 if ! [[ -f "$tzDir"/"$ARG1" ]]; then
251 yell
"ERROR:Invalid time zone argument.";
254 # Export ARG1 as TZ environment variable
255 TZ
="$ARG1" && export TZ
&& returnState
="true";
258 # Determine function return code
259 if [ "$returnState" = "true" ]; then
262 } # Exports TZ environment variable
264 # Desc: Report seconds until next day.
265 # Output: stdout: integer seconds until next day
266 # Output: exit code 0 if stdout > 0; 1 if stdout = 0; 2 if stdout < 0
267 # Usage: timeUntilNextDay
268 # Usage: if ! myTTL="$(timeUntilNextDay)"; then yell "ERROR in if statement"; exit 1; fi
269 local returnState TIME_CURRENT TIME_NEXT_DAY SECONDS_UNTIL_NEXT_DAY
270 TIME_CURRENT
="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
271 TIME_NEXT_DAY
="$(date -d "$TIME_CURRENT next day
" --iso-8601=date)"; # Produce timestamp of beginning of tomorrow with resolution of 1 second.
272 SECONDS_UNTIL_NEXT_DAY
="$(( $(date +%s -d "$TIME_NEXT_DAY") - $(date +%s -d "$TIME_CURRENT") ))" ; # Calculate seconds until closest future midnight (res. 1 second).
273 if [[ "$SECONDS_UNTIL_NEXT_DAY" -gt 0 ]]; then
275 elif [[ "$SECONDS_UNTIL_NEXT_DAY" -eq 0 ]]; then
276 returnState
="WARNING_ZERO";
277 yell
"WARNING:Reported time until next day exactly zero.";
278 elif [[ "$SECONDS_UNTIL_NEXT_DAY" -lt 0 ]]; then
279 returnState
="WARNING_NEGATIVE";
280 yell
"WARNING:Reported time until next day is negative.";
283 try
echo "$SECONDS_UNTIL_NEXT_DAY"; # Report
285 #===Determine function return code===
286 if [[ "$returnState" = "true" ]]; then
288 elif [[ "$returnState" = "WARNING_ZERO" ]]; then
290 elif [[ "$returnState" = "WARNING_NEGATIVE" ]]; then
293 } # Report seconds until next day
295 # Desc: Report seconds until next hour
296 # Output: stdout: integer seconds until next hour
297 # Output: exit code 0 if stdout > 0; 1 if stdout = 0; 2 if stdout < 0
298 # Usage: timeUntilNextHour
299 # Usage: if ! myTTL="$(timeUntilNextHour)"; then yell "ERROR in if statement"; exit 1; fi
300 local returnState TIME_CURRENT TIME_NEXT_HOUR SECONDS_UNTIL_NEXT_HOUR
301 TIME_CURRENT
="$(date --iso-8601=seconds)"; # Produce `date`-parsable current timestamp with resolution of 1 second.
302 TIME_NEXT_HOUR
="$(date -d "$TIME_CURRENT next hour
" --iso-8601=hours)"; # Produce `date`-parsable current time stamp with resolution of 1 second.
303 SECONDS_UNTIL_NEXT_HOUR
="$(( $(date +%s -d "$TIME_NEXT_HOUR") - $(date +%s -d "$TIME_CURRENT") ))"; # Calculate seconds until next hour (res. 1 second).
304 if [[ "$SECONDS_UNTIL_NEXT_HOUR" -gt 0 ]]; then
306 elif [[ "$SECONDS_UNTIL_NEXT_HOUR" -eq 0 ]]; then
307 returnState
="WARNING_ZERO";
308 yell
"WARNING:Reported time until next hour exactly zero.";
309 elif [[ "$SECONDS_UNTIL_NEXT_HOUR" -lt 0 ]]; then
310 returnState
="WARNING_NEGATIVE";
311 yell
"WARNING:Reported time until next hour is negative.";
314 try
echo "$SECONDS_UNTIL_NEXT_HOUR"; # Report
316 #===Determine function return code===
317 if [[ "$returnState" = "true" ]]; then
319 elif [[ "$returnState" = "WARNING_ZERO" ]]; then
321 elif [[ "$returnState" = "WARNING_NEGATIVE" ]]; then
324 } # Report seconds until next hour
326 # Desc: Timestamp without separators (YYYYmmddTHHMMSS+zzzz)
327 # Usage: dateTimeShort
328 # Output: stdout: timestamp (ISO-8601, no separators)
329 local TIME_CURRENT TIME_CURRENT_SHORT
330 TIME_CURRENT
="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
331 TIME_CURRENT_SHORT
="$(date -d "$TIME_CURRENT" +%Y%m%dT%H%M%S%z)"; # Produce separator-less current timestamp with resolution 1 second.
332 echo "$TIME_CURRENT_SHORT";
333 } # Get YYYYmmddTHHMMSS±zzzz
335 # Desc: Date without separators (YYYYmmdd)
337 # Output: stdout: date (ISO-8601, no separators)
338 local TIME_CURRENT DATE_CURRENT_SHORT
339 TIME_CURRENT
="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
340 DATE_CURRENT_SHORT
="$(date -d "$TIME_CURRENT" +%Y%m%d)"; # Produce separator-less current date with resolution 1 day.
341 echo "$DATE_CURRENT_SHORT";
344 # Desc: Output approximate time duration string before given time (default:current date)
345 # Ref/Attrib: ISO-8601:2004(E), §4.4.4.2 Representations of time intervals by duration and context information
346 # Note: "1 month" ("P1M") is assumed to be "30 days" (see ISO-8601:2004(E), §2.2.1.2)
347 # Usage: timeDuration [arg1] ([arg2])
348 # Input: arg1: seconds as base 10 integer >= 0 (ex: 3601)
349 # arg2: precision level (optional; default=2)
350 # Output: stdout: ISO-8601 duration string (ex: "P1H1S", "P2Y10M15DT10H30M20S")
351 # Example: 'timeDuration 111111 3' yields 'P1DT6H51M'
352 # Depends: date 8 (gnucoreutils)
353 local returnState fullHours fullMinutes fullSeconds
;
356 precision
=2; # set default precision
357 returnState
="true"; # set default return state
359 # Check that between one and two arguments is supplied
360 if ! { [[ $# -ge 1 ]] && [[ $# -le 2 ]]; }; then
361 yell
"ERROR:Invalid number of arguments:$# . Exiting.";
362 returnState
="ERROR_INPUT"; fi
364 # Check that arg1 provided
365 if [[ $# -ge 1 ]]; then
366 # Check that arg1 is a positive integer
367 if [[ "$ARG1" =~ ^
[[:digit
:]]+$
]]; then
370 yell
"ERROR:ARG1 not a digit.";
371 returnState
="ERROR_INPUT";
375 yell
"ERROR:No argument provided. Exiting.";
379 # Consider whether arg2 was provided
380 if [[ $# -eq 2 ]]; then
381 # Check that the second arg is a positive integer
382 if [[ "$ARG2" =~ ^
[[:digit
:]]+$
]] && [[ "ARG2" -gt 0 ]]; then
386 yell
"ERROR:ARG2 not a positive integer. (is $ARG2 ). Leaving early.";
387 returnState
="ERROR_INPUT";
394 remainder
="$ARG1" ; # seconds
395 ## Calculate full years Y, update remainder
396 fullYears
=$
(( remainder
/ (365*24*60*60) ));
397 remainder
=$
(( remainder
- (fullYears
*365*24*60*60) ));
398 ## Calculate full months M, update remainder
399 fullMonths
=$
(( remainder
/ (30*24*60*60) ));
400 remainder
=$
(( remainder
- (fullMonths
*30*24*60*60) ));
401 ## Calculate full days D, update remainder
402 fullDays
=$
(( remainder
/ (24*60*60) ));
403 remainder
=$
(( remainder
- (fullDays
*24*60*60) ));
404 ## Calculate full hours H, update remainder
405 fullHours
=$
(( remainder
/ (60*60) ));
406 remainder
=$
(( remainder
- (fullHours
*60*60) ));
407 ## Calculate full minutes M, update remainder
408 fullMinutes
=$
(( remainder
/ (60) ));
409 remainder
=$
(( remainder
- (fullMinutes
*60) ));
410 ## Calculate full seconds S, update remainder
411 fullSeconds
=$
(( remainder
/ (1) ));
412 remainder
=$
(( remainder
- (remainder
*1) ));
413 ## Check which fields filled
414 if [[ $fullYears -gt 0 ]]; then hasYears
="true"; else hasYears
="false"; fi
415 if [[ $fullMonths -gt 0 ]]; then hasMonths
="true"; else hasMonths
="false"; fi
416 if [[ $fullDays -gt 0 ]]; then hasDays
="true"; else hasDays
="false"; fi
417 if [[ $fullHours -gt 0 ]]; then hasHours
="true"; else hasHours
="false"; fi
418 if [[ $fullMinutes -gt 0 ]]; then hasMinutes
="true"; else hasMinutes
="false"; fi
419 if [[ $fullSeconds -gt 0 ]]; then hasSeconds
="true"; else hasSeconds
="false"; fi
421 ## Determine which fields to display (see ISO-8601:2004 §4.4.3.2)
422 witherPrecision
="false"
425 if $hasYears && [[ $precision -gt 0 ]]; then
427 witherPrecision
="true";
429 displayYears
="false";
431 if $witherPrecision; then ((precision--
)); fi;
434 if $hasMonths && [[ $precision -gt 0 ]]; then
435 displayMonths
="true";
436 witherPrecision
="true";
438 displayMonths
="false";
440 if $witherPrecision && [[ $precision -gt 0 ]]; then
441 displayMonths
="true";
443 if $witherPrecision; then ((precision--
)); fi;
446 if $hasDays && [[ $precision -gt 0 ]]; then
448 witherPrecision
="true";
452 if $witherPrecision && [[ $precision -gt 0 ]]; then
455 if $witherPrecision; then ((precision--
)); fi;
458 if $hasHours && [[ $precision -gt 0 ]]; then
460 witherPrecision
="true";
462 displayHours
="false";
464 if $witherPrecision && [[ $precision -gt 0 ]]; then
467 if $witherPrecision; then ((precision--
)); fi;
470 if $hasMinutes && [[ $precision -gt 0 ]]; then
471 displayMinutes
="true";
472 witherPrecision
="true";
474 displayMinutes
="false";
476 if $witherPrecision && [[ $precision -gt 0 ]]; then
477 displayMinutes
="true";
479 if $witherPrecision; then ((precision--
)); fi;
483 if $hasSeconds && [[ $precision -gt 0 ]]; then
484 displaySeconds
="true";
485 witherPrecision
="true";
487 displaySeconds
="false";
489 if $witherPrecision && [[ $precision -gt 0 ]]; then
490 displaySeconds
="true";
492 if $witherPrecision; then ((precision--
)); fi;
496 ## Determine whether or not the "T" separator is needed to separate date and time elements
497 if ( $displayHours ||
$displayMinutes ||
$displaySeconds); then
498 displayDateTime
="true"; else displayDateTime
="false"; fi
500 ## Construct duration output string
502 if $displayYears; then
503 OUTPUT
=$OUTPUT$fullYears"Y"; fi
504 if $displayMonths; then
505 OUTPUT
=$OUTPUT$fullMonths"M"; fi
506 if $displayDays; then
507 OUTPUT
=$OUTPUT$fullDays"D"; fi
508 if $displayDateTime; then
509 OUTPUT
=$OUTPUT"T"; fi
510 if $displayHours; then
511 OUTPUT
=$OUTPUT$fullHours"H"; fi
512 if $displayMinutes; then
513 OUTPUT
=$OUTPUT$fullMinutes"M"; fi
514 if $displaySeconds; then
515 OUTPUT
=$OUTPUT$fullSeconds"S"; fi
517 ## Output duration string to stdout
518 if [[ "$returnState" = "true" ]]; then echo "$OUTPUT"; fi
520 #===Determine function return code===
521 if [ "$returnState" = "true" ]; then
524 echo "$returnState" 1>&2;
528 } # Get duration (ex: PT10M4S )
530 # Desc: Displays missing apps, files, and dirs
531 # Usage: displayMissing
532 # Input: associative arrays: appRollCall, fileRollCall, dirRollCall
533 # Output: stderr messages
534 #==BEGIN Display errors==
535 #===BEGIN Display Missing Apps===
536 missingApps
="Missing apps :"
537 #for key in "${!appRollCall[@]}"; do echo "DEBUG:$key => ${appRollCall[$key]}"; done
538 for key
in "${!appRollCall[@]}"; do
539 value
="${appRollCall[$key]}"
540 if [ "$value" = "false" ]; then
541 #echo "DEBUG:Missing apps: $key => $value";
542 missingApps
="$missingApps""$key "
546 if [ "$appMissing" = "true" ]; then # Only indicate if an app is missing.
547 echo "$missingApps" 1>&2;
549 #===END Display Missing Apps===
551 #===BEGIN Display Missing Files===
552 missingFiles
="Missing files:"
553 #for key in "${!fileRollCall[@]}"; do echo "DEBUG:$key => ${fileRollCall[$key]}"; done
554 for key
in "${!fileRollCall[@]}"; do
555 value
="${fileRollCall[$key]}"
556 if [ "$value" = "false" ]; then
557 #echo "DEBUG:Missing files: $key => $value";
558 missingFiles
="$missingFiles""$key "
562 if [ "$fileMissing" = "true" ]; then # Only indicate if an app is missing.
563 echo "$missingFiles" 1>&2;
565 #===END Display Missing Files===
567 #===BEGIN Display Missing Directories===
568 missingDirs
="Missing dirs:"
569 #for key in "${!dirRollCall[@]}"; do echo "DEBUG:$key => ${dirRollCall[$key]}"; done
570 for key
in "${!dirRollCall[@]}"; do
571 value
="${dirRollCall[$key]}"
572 if [ "$value" = "false" ]; then
573 #echo "DEBUG:Missing dirs: $key => $value";
574 missingDirs
="$missingDirs""$key "
578 if [ "$dirMissing" = "true" ]; then # Only indicate if an dir is missing.
579 echo "$missingDirs" 1>&2;
581 #===END Display Missing Directories===
583 #==END Display errors==
584 } # Display missing apps, files, dirs
586 #Desc: Sets script TTL
587 #Usage: setScriptTTL arg1
588 #Input: arg1: "day" or "hour"
590 #Depends: timeUntilNextHour or timeUntilNextDay
593 if [[ "$ARG1" = "day" ]]; then
594 # Set script lifespan to end at start of next day
595 if ! scriptTTL
="$(timeUntilNextDay)"; then
596 if [[ "$scriptTTL" -eq 0 ]]; then
597 ((scriptTTL
++)); # Add 1 because 0 would cause 'timeout' to never timeout.
599 yell
"ERROR: timeUntilNextDay exit code $?"; exit 1;
602 elif [[ "$ARG1" = "hour" ]]; then
603 # Set script lifespan to end at start of next hour
604 if ! scriptTTL
="$(timeUntilNextHour)"; then
605 if [[ "$scriptTTL" -eq 0 ]]; then
606 ((scriptTTL
++)); # Add 1 because 0 would cause 'timeout' to never timeout.
608 yell
"ERROR: timeUntilNextHour exit code $?"; exit 1;
612 yell
"ERROR:Invalid argument for setScriptTTL function."; exit 1;
614 } # Seconds until next (day|hour).
616 processArguments
"$@" # Process arguments.
618 # Determine working directory
619 ## Set DIR_TMP_PARENT to user-specified value if specified
620 if [[ "$OPTION_TMPDIR" = "true" ]]; then
621 if [[ -d "$TMP_DIR_PRIORITY" ]]; then
622 DIR_TMP_PARENT
="$OPTION_TMPDIR";
624 yell
"WARNING:Specified temporary working directory not valid:$OPTION_TMP_DIR";
629 ## Set DIR_TMP_PARENT to default or fallback otherwise
630 if [[ -d "$DIR_TMP_DEFAULT" ]]; then
631 DIR_TMP_PARENT
="$DIR_TMP_DEFAULT";
632 elif [[ -d /tmp
]]; then
633 yell
"WARNING:/dev/shm not available. Falling back to /tmp .";
634 DIR_TMP_PARENT
="/tmp";
636 yell
"ERROR:No valid working directory available. Exiting.";
640 ## Set DIR_TMP using DIR_TMP_PARENT and nonce (SCRIPT_TIME_START)
641 DIR_TMP
="$DIR_TMP_PARENT"/"$SCRIPT_TIME_START""..bkgpslog"; # Note: removed at end of main().
643 # Set output encryption and compression option strings
644 if [[ "$OPTION_ENCRYPT" = "true" ]]; then # Check if encryption option active.
645 if checkapp age
; then # Check that age is available.
646 for pubkey
in "${recPubKeys[@]}"; do # Validate recipient pubkey strings by forming test message
647 vbm
"DEBUG:Testing pubkey string:$pubkey"
648 if echo "butts" | age
-a -r "$pubkey" 1>/dev
/null
; then
649 # Form age recipient string
650 recipients
="$recipients""-r $pubkey ";
651 vbm
"Added pubkey for forming age recipient string:""$pubkey";
652 vbm
"DEBUG:recipients:""$recipients";
654 yell
"ERROR:Exit code ""$?"". Invalid recipient pubkey string. Exiting."; exit 1;
657 vbm
"DEBUG:Finished processing recPubKeys array";
658 # Form age command string
659 CMD_ENCRYPT
="age ""$recipients ";
660 CMD_ENCRYPT_SUFFIX
=".age";
662 yell
"ERROR:Encryption enabled but \"age\" not found. Exiting."; exit 1;
665 CMD_ENCRYPT
="tee /dev/null ";
666 CMD_ENCRYPT_SUFFIX
="";
667 vbm
"DEBUG:Encryption not enabled."
669 if [[ "$OPTION_COMPRESS" = "true" ]]; then # Check if compression option active
670 if checkapp
gzip; then # Check if gzip available
671 CMD_COMPRESS
="gzip ";
672 CMD_COMPRESS_SUFFIX
=".gz";
674 yell
"ERROR:Compression enabled but \"gzip\" not found. Exiting."; exit 1;
677 CMD_COMPRESS
="tee /dev/null ";
678 CMD_COMPRESS_SUFFIX
="";
679 vbm
"DEBUG:Compression not enabled."
682 # Check that critical apps and dirs are available, displag missing ones.
683 if ! checkapp gpspipe
tar && ! checkdir
"$DIR_OUT" "/dev/shm"; then
684 yell
"ERROR:Critical components missing.";
685 displayMissing
; yell
"Exiting."; exit 1; fi
687 # Set script lifespan
688 setScriptTTL
"$SCRIPT_TTL";
690 # File name substring: encoded bufferTTL
691 bufferTTL_STR
="$(timeDuration $BUFFER_TTL)";
693 # Init temp working dir
694 try mkdir
"$DIR_TMP" && vbm
"DEBUG:Working dir creatd at:$DIR_TMP"
696 # Initialize 'tar' archive
697 ## Define output tar path (note: each day gets *one* tar file (Ex: "20200731..hostname_location.[.gpx.gz].tar"))
698 PATHOUT_TAR
="$DIR_OUT"/"$(dateShort)"..
"$SCRIPT_HOSTNAME""_location""$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX".
tar
699 ## Write bkgpslog version to DIR_TMP/VERSION
700 echo "$0"" Version:""$SCRIPT_VERSION" >> "$DIR_TMP/VERSION" && vbm
"DEBUG:VERSION created."
701 ## Create empty tar archive at PATHOUT_TAR
702 try
tar --create --directory="$DIR_TMP" --file="$PATHOUT_TAR" --files-from=/dev
/null
&& vbm
"DEBUG:""$PATHOUT_TAR"" created."
703 ## Append VERSION file to PATHOUT_TAR
704 try
tar --append --directory="$DIR_TMP" --file="$PATHOUT_TAR" "VERSION" && vbm
"DEBUG:VERSION added to $PATHOUT_TAR"
706 # Record gps data until script lifespan ends
707 declare debugCounter
; debugCounter
="0"; # set debug counter
708 timeStart
=$
(dateTimeShort
); # Note start time
709 while [[ "$SECONDS" -lt "$scriptTTL" ]]; do
710 # Determine file paths (time is start of buffer period)
711 FILEOUT_BASENAME
="$timeStart""--""$bufferTTL_STR""..""$SCRIPT_HOSTNAME""_location" ; # ISO-8601 YYYYmmddTHHMMSS+zzP[$bufferTTL]S
712 ## Files saved to DIR_TMP
713 PATHOUT_NMEA
="$DIR_TMP"/"$FILEOUT_BASENAME".nmea
"$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX" ;
714 PATHOUT_GPX
="$DIR_TMP"/"$FILEOUT_BASENAME".gpx
"$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX" ;
715 PATHOUT_KML
="$DIR_TMP"/"$FILEOUT_BASENAME".kml
"$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX" ;
716 ## Files saved to disk (DIR_OUT)
717 ### one file per day (Ex: "20200731..hostname_location.[.gpx.gz].tar")
718 PATHOUT_TAR
="$DIR_OUT"/"$(dateShort)"..
"$SCRIPT_HOSTNAME""_location""$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX".
tar
719 # Define GPS conversion commands
720 CMD_CONV_NMEA
="tee /dev/null " ; # tee as passthrough
721 CMD_CONV_GPX
="gpsbabel -i nmea -f - -o gpx -F - " ; # convert NMEA to GPX
722 CMD_CONV_KML
="gpsbabel -i nmea -f - -o kml -F - " ; # convert NMEA to KML
723 # Fill Bash variable buffer
724 bufferBash
="$(timeout "$BUFFER_TTL""s
" gpspipe -r)"; # Record gpspipe nmea data to buffer for bufferTTL seconds
725 # Process bufferBash, save secured chunk set to DIR_TMP
726 echo "$bufferBash" |
$CMD_CONV_NMEA |
$CMD_COMPRESS |
$CMD_ENCRYPT > "$PATHOUT_NMEA" & # Create NMEA file (secured if requested)
727 echo "$bufferBash" |
$CMD_CONV_GPX |
$CMD_COMPRESS |
$CMD_ENCRYPT > "$PATHOUT_GPX" & # Create GPX file (secured if requested)
728 echo "$bufferBash" |
$CMD_CONV_KML |
$CMD_COMPRESS |
$CMD_ENCRYPT > "$PATHOUT_KML" & # Create KML file (secured if requested)
729 vbm
"DEBUG:Completed buffer session $debugCounter ." 1>&2;
730 # Append each secured chunk in memory dir (DIR_TMP) to file on disk (PATHOUT_TAR in DIR_OUT)
731 try
tar --append --directory="$(dirname $"PATHOUT_NMEA
")" --file="$PATHOUT_TAR" "$(basename "$PATHOUT_NMEA")" && \
732 vbm
"DEBUG:Appended NMEA location data $PATHOUT_NMEA to $PATHOUT_TAR";
733 try
tar --append --directory="$(dirname $"PATHOUT_GPX
")" --file="$PATHOUT_TAR" "$(basename "$PATHOUT_GPX")" && \
734 vbm
"DEBUG:Appended GPX location data $PATHOUT_GPX to $PATHOUT_TAR";
735 try
tar --append --directory="$(dirname $"PATHOUT_KML
")" --file="$PATHOUT_TAR" "$(basename "$PATHOUT_KML")" && \
736 vbm
"DEBUG:Appended KML location $PATHOUT_KML to $PATHOUT_TAR";
737 # Remove secured chunks from DIR_TMP
738 try
rm "$PATHOUT_NMEA" "$PATHOUT_NMEA" "$PATHOUT_NMEA";
739 # Reset buffer and filenames
740 unset bufferBash FILEOUT_BASENAME PATHOUT_NMEA PATHOUT_GPX PATHOUT_KML PATHOUT_TAR
;
745 try
rm -r "$DIR_TMP";
747 #===END Declare local script functions===
748 #==END Define script parameters==
751 #==BEGIN Perform work and exit==
752 main
"$@" # Run main function.
754 #==END Perform work and exit==